/*
  * Copyright 2015 The CHOReVOLUTION project
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
  * you may not use this file except in compliance with the License.
  * You may obtain a copy of the License at
  *
  *      http://www.apache.org/licenses/LICENSE-2.0
  *
  * Unless required by applicable law or agreed to in writing, software
  * distributed under the License is distributed on an "AS IS" BASIS,
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
  */
package eu.chorevolution.transformations.clts2coord;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import eu.chorevolution.modelingnotations.clts.Choreography;

public class Transformator {
	
	private CLTSManager cltsManager;
	private List<COORDManager> coordManagers; 
	
	public Transformator(File cltsFile) throws TransformatorException {
		cltsManager = new CLTSManager(cltsFile);
		coordManagers = new ArrayList<COORDManager>();
	}

	public List<COORDManager> transform() throws TransformatorException {
		for (Choreography choreography : cltsManager.getChoreographies()) {
			TransformatorManager manager = new TransformatorManager(choreography);
			coordManagers.add(manager.getCOORDManager());
		}
		return coordManagers;
	}

	public List<COORDManager> getCoordManagers() throws TransformatorException{
		if (coordManagers.isEmpty()){
			return transform();
		}
		return coordManagers;
	}


}
